<?php
/* 
 * Payment modules - XML Asynchronous Plugin Base Class
 */

require_once dirname(__FILE__) ."/based_on_xml.class.inc";

class xml_asynchronous extends based_on_xml
{
	var $popup;
	var $payment_method = ONLINEPAYMENT_METHOD_WALLETPAYMENT;

        function xml_asynchronous() {
            parent :: based_on_xml();
        }

	function process_request ()
	{
		$phpsessid = zen_session_name() . '=' . zen_session_id();
		$this->get_redirect_url($this->response_parameters);
		
		if (in_array("xml_online_transfer", class_parents($this)) && $this->popup)
		{
			$_SESSION['FRAME_URL'] = zen_href_link(FILENAME_RESPONSE, 'payment_module=' .$this->code. '&REDIRECT_TO='.SERVER_REDIRECT, 'SSL', true, false);
			$_SESSION['OT_URL'] = $this->complete_redirect_url;
			$_SESSION['REDIRECT_TO'] = SERVER_REDIRECT;
		}
		else
		{
			$_SESSION['FRAME_URL'] = zen_href_link(FILENAME_CHECKOUT_REDIRECT, 'payment_module=' .$this->code, 'SSL', true, false);
		}
		
		$_SESSION[$this->code. "_PARAMETERS"] = $this->parameters_to_post;
		$_SESSION['URL_REDIRECTEDTO'] = $this->main_redirect_url;
				
		//$_SESSION['FRAME_URL'] = $this->main_redirect_url;
		
		create_log("Step 2: Async payment", "", "Redirecting shopper to execute payment (browser side POST redirect using a form submitted by javascript)", 
			"URL", $this->main_redirect_url,
	        "METHOD", "POST",
			"Parameter", print_r($this->parameters_to_post, true),
			"Waiting for the user to execute payment on " .$this->code ." side ... ");
		/*
        create_log("=Step 2: Async payment= \n== Redirecting shopper to execute payment (browser side POST redirect using a form submitted by javascript)== " 
			."\nURL: " .$this->main_redirect_url ."\nMETHOD: POST \n=== Parameters ===\n"
			. print_r($this->parameters_to_post, true)
			."\nWaiting for the user to execute payment on " .$this->code ." side ... ");
		*/
	}

	function set_params ()
	{
		parent::set_params();
		
		// account
		$this->request_parameters->account_brand = $this->brand;
		$this->request_parameters->account_id = $this->current_order->customer['email_address'];
		$this->request_parameters->payment_code = base_plugin::get_payment_code(ONLINEPAYMENT_METHOD_WALLETPAYMENT, PAYMENT_TYPE_DEBIT);
		// frontend
		$this->request_parameters->frontend_response_url = zen_href_link(FILENAME_RESPONSE, 'payment_module=' .$this->code, 'NONSSL', true, false);
		$this->request_parameters->frontend_session_id = zen_session_id();
		// decode & character
		$this->request_parameters->frontend_response_url = str_replace('&amp;', '&', $this->request_parameters->frontend_response_url);
	}
}

?>
