<?php

function create_log()
{
    //$border = "\n----------------------------------------------------------------\n";
    //$_SESSION['LOG'] = $_SESSION['LOG'] .$log .$border;
    //append_to_log_file($log .$border);
    
    $args = func_get_args();
    
    $logs['title'] = $args[0];
    $logs['block'] = array($args[1], $args[2]);
    for ($i=3; $i<count($args); $i++)
    {
        $logs['vars'][] = $args[$i];
    }
    
    if ($logs['title'])
    {
        $title = "<h1>{$logs[title]}</h1>";
    }
    
    if ($logs['block'])
    {
        $step = "";
        if ($logs["block"][0])
        {
          $step .= "<h5>" .$logs["block"][0] ."</h5>";
        }
        if ($logs["block"][1])
        {
          $step .= "<div class=\"log desc\">" .$logs["block"][1] ."</div>";
        }
    }
    
    if ($logs['vars'])
    {
        $j = 0;
        while ($j<count($logs['vars']))
        {
            $vars .= "<div class=\"log var\"><span>" .$logs['vars'][$j] ."</span> : <pre>" .htmlentities($logs['vars'][$j+1]) ."</pre></div>";
            $j += 2;
        }
    }
    
    $log = $title .$step .$vars;
    $timestamp = date("Y-m-d h:i:s");
    $border = "<div class=\"log timestamp\">[{$timestamp}]</div>";
    $new_log = $border .$log ."<hr/>";
    $_SESSION['LOG'] = $_SESSION['LOG'] .$new_log;
    append_to_log_file($new_log);
}

function create_log_error($log)
{
    $timestamp = date("Y-m-d h:i:s");
    $border = "<div class=\"log timestamp\">[{$timestamp}]</div>";
    $new_log = $border .'<div class="log error">[Error] : ' .$log ."</div><hr/>";
    $_SESSION['LOG'] = $_SESSION['LOG'] .$new_log;
    append_to_log_file($new_log);
}

function append_to_log_file($_string)
{
    $file_name = DIR_FS_CATALOG ."cache/log_" .date("Y-m-d") .".txt";
    $fh = @fopen($file_name, 'a+') or die("can't open file log");
    fwrite($fh, $_string);
    fclose($fh);
}

// call the function if there's a request to clear the log.
if ($_POST['clearlog_request'])
{
    if (!is_null($_SESSION['LOG']))
    {
        $_SESSION['LOG'] = null;
    }
}

?>