<?php
/* 
 * Payment modules - XML Asynchronous Plugin Base Class
 */

require_once dirname(__FILE__) ."/based_on_xml.class.inc";

class xml_synchronous extends based_on_xml
{
	var $payment_method = ONLINEPAYMENT_METHOD_WALLETPAYMENT;

        function xml_synchronous() {
            parent :: based_on_xml();
        }

	function process_request ()
	{
		create_log("Executed payment of type: " .$this->code);
		// redirect to default page - no action needed
		//zen_redirect(zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'NONSSL', true, false));
	}

	function set_params ()
	{
		parent::set_params();
		
		// account
		$this->request_parameters->account_brand = $this->brand;
		$this->request_parameters->account_id = $this->current_order->customer['email_address'];
		$this->request_parameters->payment_code = base_plugin::get_payment_code(ONLINEPAYMENT_METHOD_WALLETPAYMENT, PAYMENT_TYPE_DEBIT);
	}
}

?>
